<?php 
/*
 Module de paiement Monetico pour le CM-CIC Par hosteco.fr 2012-2018. 
*/

@ini_set('display_errors', 'off');

define('__Monetico_Root__',(dirname(__FILE__)));

class Moneticoxf extends PaymentModule{
  private $_html = '';
  private $_postErrors = array();
  public  $cmcic_ver = '3.0';
    

  public function __construct(){
    $this->name = 'moneticoxf';
    $this->tab = 'payments_gateways';
    $this->version = '1.6.4.11';

    parent::__construct();
    $this->page = basename(__FILE__, '.php');
    
    $nb_fois = Configuration::get('CMCIC4X_NBMENS');    
  	$cmcic_active	= (bool)Configuration::get('CMCIC_ACTIVE');
  	$cmcic4X_active = (bool)Configuration::get('CMCIC4X_ACTIVE');
  	
  	if($cmcic4X_active && $cmcic_active) $n_fois = ' 1 & '. $nb_fois;
  	if($cmcic4X_active && !$cmcic_active) $n_fois = ' '. $nb_fois;  	
  	if(!$cmcic4X_active && $cmcic_active) $n_fois = ' 1 ';
  	if(!$cmcic4X_active && !$cmcic_active) $n_fois = ' x ';    
        
    $this->displayName = $this->l('CB Monetico Payement '). $n_fois .$this->l(' times');
    
    $this->description = $this->l('Secure payment for Monetico system banks').
    '<br><a href="http://hosteco.fr/host/module_paiement_prestashop.php" target="_blank" title="Cliquez ici pour aller sur le site de l\'Editeur"><i class="icon-search"></i>&nbsp;En savoir plus</a>
    &nbsp;<span title="" data-original-title="" class="module-badge-popular help-tooltip text-primary" data-title="Ce module est disponible sur hosteco.fr"><i class="icon-group"></i> <small>Populaires</small></span>
		- <span title="" data-original-title="" class="module-badge-partner help-tooltip text-warning" data-title="Module Professionnel, réalisé par un spécialiste des systèmes de paiement !"><i class="icon-pushpin"></i> <small>Professionnel</small>';   
    
    $this->confirmUninstall = $this->l('Are you sure to delete this module ?');
  	$this->author = 'Hosteco.fr';
  
 		$this->currencies = true;
		$this->currencies_mode = 'radio';  

    $shop_id = $this->context->shop->id;
    $shop_uri = $_SERVER['HTTP_HOST'];
    $shop_ql = "SELECT * FROM "._DB_PREFIX_."shop_url WHERE id_shop ='".$shop_id."'";
    if ($shop = Db::getInstance()->getRow($shop_ql))
    
$this->http = 'http://';
if(isset($_SERVER["SCRIPT_URI"])){if(substr($_SERVER["SCRIPT_URI"],0,5) == 'https') {$this->http = 'https://';}	else {$this->http = 'http://';}} 
if(isset($_SERVER['REQUEST_SCHEME'])){if(substr($_SERVER["REQUEST_SCHEME"],0,5) == 'https') {$this->http = 'https://';}	else {$this->http = 'http://';}} 
    
    $sql_e = "SELECT * FROM "._DB_PREFIX_."employee WHERE id_employee ='1'";
    if ($row_e = Db::getInstance()->getRow($sql_e))
    $this->email_admin = $row_e['email'];		
  }

  public function install(){
    if (!parent::install()
		OR !Configuration::updateValue('CMCIC_ACTIVE', 'on')
    OR !Configuration::updateValue('CMCIC_TPE', '12345678')
    OR !Configuration::updateValue('CMCIC_CLE', '0123456789ABCDEF0123456789ABCDEF01234567')
    OR !Configuration::updateValue('CMCIC_VERSION', $this->cmcic_ver)
    OR !Configuration::updateValue('CMCIC_SERVEUR', 'https://p.monetico-services.com/test/paiement.cgi')
    OR !Configuration::updateValue('CMCIC_CODESOCIETE', 'codesociete')
		OR !Configuration::updateValue('CMCIC_MONTANTMINI', '1.00')     
		OR !Configuration::updateValue('CMCIC_EMAIL_NOTIFICATION', $this->email_admin)
		OR !Configuration::updateValue('CMCIC_IP_TEST', $_SERVER["REMOTE_ADDR"])  
		OR !Configuration::updateValue('CMCIC_IP_TEST_ACTIVE', '0')   	               
		OR !Configuration::updateValue('CMCIC4X_ACTIVE', '')
		OR !Configuration::updateValue('CMCIC4X_TPE', '12345678')
    OR !Configuration::updateValue('CMCIC4X_CLE', '0123456789ABCDEF0123456789ABCDEF01234567')
    OR !Configuration::updateValue('CMCIC4X_VERSION', $this->cmcic_ver)
    OR !Configuration::updateValue('CMCIC4X_SERVEUR', 'https://p.monetico-services.com/test/paiement.cgi')
    OR !Configuration::updateValue('CMCIC4X_CODESOCIETE', 'codesociete')
		OR !Configuration::updateValue('CMCIC4X_MONTANTMINI', '15.00')
		OR !Configuration::updateValue('CMCIC4X_NBMENS', '3')
		OR !Configuration::updateValue('CMCIC4X_MODECALCUL', '1')
		OR !Configuration::updateValue('CMCIC4X_IP_TEST', $_SERVER["REMOTE_ADDR"])  
		OR !Configuration::updateValue('CMCIC4X_IP_TEST_ACTIVE', '0')   		
		OR !$this->registerHook('orderConfirmation')
		OR !$this->registerHook('payment')){
			return false;
		}
    return true;
  }

  public function uninstall(){
    if (!Configuration::deleteByName('CMCIC_ACTIVE')
		OR !Configuration::deleteByName('CMCIC_TPE')
    OR !Configuration::deleteByName('CMCIC_CLE')
    OR !Configuration::deleteByName('CMCIC_VERSION')
    OR !Configuration::deleteByName('CMCIC_SERVEUR')
    OR !Configuration::deleteByName('CMCIC_CODESOCIETE')
		OR !Configuration::deleteByName('CMCIC_MONTANTMINI') 
		OR !Configuration::deleteByName('CMCIC_EMAIL_NOTIFICATION')     
		OR !Configuration::deleteByName('CMCIC_IP_TEST')  
		OR !Configuration::deleteByName('CMCIC_IP_TEST_ACTIVE') 		
		OR !Configuration::deleteByName('CMCIC4X_ACTIVE')
		OR !Configuration::deleteByName('CMCIC4X_TPE')
		OR !Configuration::deleteByName('CMCIC4X_CLE')
		OR !Configuration::deleteByName('CMCIC4X_VERSION')
		OR !Configuration::deleteByName('CMCIC4X_SERVEUR')
		OR !Configuration::deleteByName('CMCIC4X_CODESOCIETE')
		OR !Configuration::deleteByName('CMCIC4X_MONTANTMINI')
		OR !Configuration::deleteByName('CMCIC4X_NBMENS')
		OR !Configuration::deleteByName('CMCIC4X_MODECALCUL')
		OR !Configuration::deleteByName('CMCIC4X_IP_TEST')	
		OR !Configuration::deleteByName('CMCIC4X_IP_TEST_ACTIVE') 		
    OR !parent::uninstall())
        return false;
    return true;
  }

  public function getContent()
  {
       	
	$this->display_entete();
	
	if (Tools::isSubmit('submitCmCic')){
	
		//Paiement en une fois début//
		
		if(Tools::getValue('CMCIC_ACTIVE')=='on'){
			if (!Tools::getValue('CMCIC_TPE')){
				$this->_postErrors[] = $this->l('TPE number is required');
			} else {
				Configuration::updateValue('CMCIC_TPE', Tools::getValue('CMCIC_TPE'));
			}
			if (!Tools::getValue('CMCIC_CLE')){
				$this->_postErrors[] = $this->l('HMAC key is required');
			} else {
				Configuration::updateValue('CMCIC_CLE', Tools::getValue('CMCIC_CLE'));
			}
			if (!Tools::getValue('CMCIC_CODESOCIETE')){
				$this->_postErrors[] = $this->l('Company code is required');
			} else {
				Configuration::updateValue('CMCIC_CODESOCIETE', Tools::getValue('CMCIC_CODESOCIETE'));
			}
		} else {
			Configuration::updateValue('CMCIC_TPE', Tools::getValue('CMCIC_TPE'));
			Configuration::updateValue('CMCIC_CLE', Tools::getValue('CMCIC_CLE'));
			Configuration::updateValue('CMCIC_CODESOCIETE', Tools::getValue('CMCIC_CODESOCIETE'));
		}
		
		//Paiement en une fois fin//
	
		//Paiement en plusieurs fois début//
		
		if(Tools::getValue('CMCIC4X_ACTIVE')=='on'){
			if (!Tools::getValue('CMCIC4X_TPE')){
				$this->_postErrors[] = $this->l('TPE number is required');
			} else {
				Configuration::updateValue('CMCIC4X_TPE', Tools::getValue('CMCIC4X_TPE'));
			}
			if (!Tools::getValue('CMCIC4X_CLE')){
				$this->_postErrors[] = $this->l('HMAC key is required');
			} else {
				Configuration::updateValue('CMCIC4X_CLE', Tools::getValue('CMCIC4X_CLE'));
			}
			if (!Tools::getValue('CMCIC4X_CODESOCIETE')){
				$this->_postErrors[] = $this->l('Company code is required');
			} else {
				Configuration::updateValue('CMCIC4X_CODESOCIETE', Tools::getValue('CMCIC4X_CODESOCIETE'));
			}
		} else {
			Configuration::updateValue('CMCIC4X_TPE', Tools::getValue('CMCIC4X_TPE'));
			Configuration::updateValue('CMCIC4X_CLE', Tools::getValue('CMCIC4X_CLE'));
			Configuration::updateValue('CMCIC4X_CODESOCIETE', Tools::getValue('CMCIC4X_CODESOCIETE'));
		}
		
		//Paiement en plusieurs fois fin//

		//Autres paramètres de configuration//
		
		Configuration::updateValue('CMCIC_ACTIVE', Tools::getValue('CMCIC_ACTIVE'));
		Configuration::updateValue('CMCIC_SERVEUR', Tools::getValue('CMCIC_SERVEUR'));
		Configuration::updateValue('CMCIC_VERSION',  Tools::getValue('CMCIC_VERSION'));
    Configuration::updateValue('CMCIC4X_ACTIVE', Tools::getValue('CMCIC4X_ACTIVE'));
		Configuration::updateValue('CMCIC4X_SERVEUR', Tools::getValue('CMCIC4X_SERVEUR'));
		Configuration::updateValue('CMCIC4X_VERSION', Tools::getValue('CMCIC4X_VERSION'));
		Configuration::updateValue('CMCIC_MONTANTMINI', Tools::getValue('CMCIC_MONTANTMINI'));		
		Configuration::updateValue('CMCIC4X_MONTANTMINI', Tools::getValue('CMCIC4X_MONTANTMINI'));
		Configuration::updateValue('CMCIC4X_NBMENS', Tools::getValue('CMCIC4X_NBMENS'));
		Configuration::updateValue('CMCIC4X_MODECALCUL', Tools::getValue('CMCIC4X_MODECALCUL'));
		Configuration::updateValue('CMCIC_EMAIL_NOTIFICATION', Tools::getValue('CMCIC_EMAIL_NOTIFICATION'));
		Configuration::updateValue('CMCIC_IP_TEST', Tools::getValue('CMCIC_IP_TEST'));
		Configuration::updateValue('CMCIC_IP_TEST_ACTIVE', Tools::getValue('CMCIC_IP_TEST_ACTIVE'));    	       	
		Configuration::updateValue('CMCIC4X_IP_TEST', Tools::getValue('CMCIC4X_IP_TEST'));
		Configuration::updateValue('CMCIC4X_IP_TEST_ACTIVE', Tools::getValue('CMCIC4X_IP_TEST_ACTIVE'));    	    	
        
		if($this->_postErrors){
			$this->displayErrors();
		} else {
			$this->displayConf();
		}


	}
	
    $this->_displayForm();
    return $this->_html;
 }
  
  public function displayConf()
  {
    $this->_html .= '
    <div class="conf confirm">
      <img src="../img/admin/ok.gif" alt="Confirmation" />
      '.$this->l('Settings Saved').'<br /><br />
    </div>';
  }
  
  public function displayErrors()
  {
    $nbErrors = sizeof($this->_postErrors);
    $this->_html .= '
    <div class="alert error">
      <h3>'.($nbErrors > 1 ? $this->l('There are') : $this->l('There is')).' '.$nbErrors.' '.($nbErrors > 1 ? $this->l('errors') : $this->l('error')).'</h3>
      <ol>';
    foreach ($this->_postErrors AS $error)
      $this->_html .= '<li>'.$error.'</li>';
    $this->_html .= '
      </ol><br /><br />
    </div>';
  }
  
  public function display_entete()
  {
    $this->_html .= '
	  <a style="float:right; margin-right:80px; margin-top:20px;" href="http://hosteco.fr/host/module_paiement_prestashop.php" target="_blank" title="Cliquez ici pour aller sur le site de l\'&eacute;diteur">
    <img src="../modules/moneticoxf/img/hosteco_g.png" height="40" /></a>      
    <img src="../modules/moneticoxf/img/monetico-paiement.png" style="float:left; margin-right:15px;" />
    <img src="../modules/moneticoxf/img/Compatible-1-5-version.png" style="float:right; margin-right:50px;" />   
    <img src="../modules/moneticoxf/img/Compatible_1_6.png" style="float:right; margin-right:50px;" />   
    <b><br /><br /><br /><br /><br />
    '.$this->l('This module allow you to accept payment with Monetico.').'</b><br />
  	'.$this->l('Banks available : CIC, Crédit Mutuel, OBC and Desjardins').'<br /><br />
    <br />
    ';
  }

  public function _displayForm(){   

	$conf = Configuration::getMultiple(array(
  'CMCIC_ACTIVE', 'CMCIC_TPE', 'CMCIC_CLE', 'CMCIC_VERSION', 'CMCIC_SERVEUR', 
  'CMCIC_CODESOCIETE', 'CMCIC_MONTANTMINI', 'CMCIC4X_ACTIVE', 'CMCIC4X_TPE', 
  'CMCIC4X_CLE', 'CMCIC4X_VERSION', 'CMCIC4X_SERVEUR', 'CMCIC4X_CODESOCIETE', 
  'CMCIC4X_MONTANTMINI', 'CMCIC4X_NBMENS', 'CMCIC4X_MODECALCUL', 
  'CMCIC_EMAIL_NOTIFICATION', 'CMCIC_IP_TEST', 'CMCIC_IP_TEST_ACTIVE', 
  'CMCIC4X_IP_TEST', 'CMCIC4X_IP_TEST_ACTIVE'));

	$CMCIC_TPE = $conf['CMCIC_TPE'];
	$CMCIC_CODESOCIETE = $conf['CMCIC_CODESOCIETE'];
  $CMCIC4X_TPE = $conf['CMCIC4X_TPE'];
	$CMCIC4X_CODESOCIETE = $conf['CMCIC4X_CODESOCIETE'];

  	$urlmonettest = 'https://p.monetico-services.com/test/paiement.cgi';
    $urlmonetprod = 'https://p.monetico-services.com/paiement.cgi';
  	$urlcictest = 'https://ssl.paiement.cic-banques.fr/test/paiement.cgi';
    $urlcicprod = 'https://ssl.paiement.cic-banques.fr/paiement.cgi';
    $urlobctest = 'https://ssl.paiement.banque-obc.fr/test/paiement.cgi';
    $urlobcprod = 'https://ssl.paiement.banque-obc.fr/paiement.cgi';
    $urlcmtest  = 'https://paiement.creditmutuel.fr/test/paiement.cgi';
    $urlcmprod  = 'https://paiement.creditmutuel.fr/paiement.cgi';
    
    $file_instal = __Monetico_Root__."/aide_instal.php"; 
    $file_ccom4 = __Monetico_Root__."/cour_ccom4.php"; 

	$this->_html .= '
	
	<style type="text/css">  
	<!-- 
	
		ul.tabs {
			margin: 0;
			padding: 0;
			float: left;
			list-style: none;
			height: 32px; 
			border-bottom: 1px solid #999;
			border-left: 1px solid #999;
			width: 100%;			
		}
		ul.tabs li {
			float: left;
			margin: 0;
			padding: 0;
			width: 250px;
			height: 31px; 
			line-height: 31px; 
			border: 1px solid #999;
			border-left: none;
			margin-bottom: -1px; 
			overflow: hidden;
			position: relative;
			background: #eaeaf0;
		}
		ul.tabs li a {
			text-decoration: none;
			color: #0072aa;
			display: block;
			font-size: 1.4em;
			text-align: center;
			outline: none;	
		}
		ul.tabs li a:hover {
			background: #fffa67;
		}
		html ul.tabs li.active, html ul.tabs li.active a:hover  {
			background: #ffffee;
			border-bottom: 1px solid #fff; 
		}
	
	--> 
	</style> 
	
	<script type="text/javascript">
	
			$(document).ready(function() {
			
			$(".tab_content").hide();
			$("ul.tabs li:first").addClass("active").show();
			$(".tab_content:first").show();

			$("ul.tabs li").click(function() {

				$("ul.tabs li").removeClass("active");
				$(this).addClass("active");
				$(".tab_content").hide();

				var activeTab = $(this).find("a").attr("href");
				$(activeTab).fadeIn();
				return false;
			});

		});
	
	</script>
	
	
	<fieldset>
		<legend style="background: #d8f5a5"><img src="../img/admin/contact.gif" />'.$this->l('Settings and Parameters').'</legend>
		<form action="'.$_SERVER['REQUEST_URI'].'" method="Post">
		
		<ul class="tabs">
			<li>
				<a href="#TabConf_01">'.$this->l('Adjustment Payment in one time').'</a>
			</li>
			<li>
				<a href="#TabConf_02">'.$this->l('Adjustment Payment in 2, 3 or 4 Times').'</a>
			</li>';
			
    if(file_exists($file_instal)) {      
  	$this->_html .= '
			<li>
				<a href="#TabConf_03">'.$this->l('Help installation').'</a>
			</li>';
     }

    if(file_exists($file_ccom4)) {      
  	$this->_html .= '
			<li>
				<a href="#TabConf_04">'.$this->l('Email to Centrecom').'</a>
			</li>';
     }
     
	$this->_html .= '</ul>			
		<div style="border: 1px solid #999;border-top: none;overflow: hidden;clear: both;float: left; width: 100%;background: #ffffee;">

		<div id="TabConf_01" class="tab_content">
			<br /><br />
        <label>'.$this->l('Monetico version :').'</label>
			  <div class="margin-form">
			  <input type="hidden" name="CMCIC_VERSION" value="'.$this->cmcic_ver.'" />V '.$this->cmcic_ver.'
			  </div>
			  <br />
			  <label>'.$this->l('Enable one time payment :').'</label>
			  <div class="margin-form">
			  <input type="checkbox" name="CMCIC_ACTIVE" value="on" '.((Tools::getValue('CMCIC_ACTIVE') or $conf['CMCIC_ACTIVE']) ? 'checked' : '').' />
        </div>
			  <br />
			  <label>'.$this->l('TPE number :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC_TPE" size=10 maxlength=8 value="'.((!Tools::getValue('CMCIC_TPE')) ? $conf['CMCIC_TPE'] : Tools::getValue('CMCIC_TPE')).'" />
			  <span>'.$this->l('Seven or eight carracters.').'</span>
			  </div>
			  <br />
			  <label>'.$this->l('Your Company code :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC_CODESOCIETE" size=20 maxlength=42 value="'.((!Tools::getValue('CMCIC_CODESOCIETE')) ? $conf['CMCIC_CODESOCIETE'] : Tools::getValue('CMCIC_CODESOCIETE')).'" />
			  <span>'.$this->l('Has been given by CMCIC.').'</span>
			  </div>
			  <br />
			  <label>'.$this->l('Key control :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC_CLE" size=60 maxlength=50 value="'.((!Tools::getValue('CMCIC_CLE')) ? $conf['CMCIC_CLE'] : Tools::getValue('CMCIC_CLE')).'" />
			  <span>'.$this->l('HMAC Key has been given by CMCIC.').'</span>
			  </div>
			  <br />
			  <label>'.$this->l('Minimum purchase :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC_MONTANTMINI" size=10 maxlength=42 value="'.((!Tools::getValue('CMCIC_MONTANTMINI')) ? $conf['CMCIC_MONTANTMINI'] : Tools::getValue('CMCIC_MONTANTMINI') ).'" />
			  <span>'.$this->l('Total amnount for the customer.').'</span>
			  </div>
			  <br />			  
			  <label>'.$this->l('Your Bank agency :').'</label>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC_SERVEUR" value="'.htmlentities($urlmonetprod).'" '.((Tools::getValue('CMCIC_SERVEUR')==htmlentities($urlmonetprod) or $conf['CMCIC_SERVEUR']==htmlentities($urlmonetprod)) ? ' checked' : '' ).'/> Monetico Production&nbsp;
			  <input type="radio" name="CMCIC_SERVEUR" value="'.htmlentities($urlmonettest).'" '.((Tools::getValue('CMCIC_SERVEUR')==htmlentities($urlmonettest) or $conf['CMCIC_SERVEUR']==htmlentities($urlmonettest)) ? ' checked' : '' ).'/> Monetico Test
			  </div>			  
			  <div class="margin-form">
			  <input type="radio" name="CMCIC_SERVEUR" value="'.htmlentities($urlcicprod).'" '.((Tools::getValue('CMCIC_SERVEUR')==htmlentities($urlcicprod) or $conf['CMCIC_SERVEUR']==htmlentities($urlcicprod)) ? ' checked' : '' ).'/> CIC Production&nbsp;
			  <input type="radio" name="CMCIC_SERVEUR" value="'.htmlentities($urlcictest).'" '.((Tools::getValue('CMCIC_SERVEUR')==htmlentities($urlcictest) or $conf['CMCIC_SERVEUR']==htmlentities($urlcictest)) ? ' checked' : '' ).'/> CIC Test
			  </div>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC_SERVEUR" value="'.htmlentities($urlcmprod).'" '.((Tools::getValue('CMCIC_SERVEUR')==htmlentities($urlcmprod) or $conf['CMCIC_SERVEUR']==htmlentities($urlcmprod)) ? ' checked' : '' ).'/> Cr&eacute;dit Mutuel Production&nbsp;
			  <input type="radio" name="CMCIC_SERVEUR" value="'.htmlentities($urlcmtest).'" '.((Tools::getValue('CMCIC_SERVEUR')==htmlentities($urlcmtest) or $conf['CMCIC_SERVEUR']==htmlentities($urlcmtest)) ? ' checked' : '' ).'/> Cr&eacute;dit Mutuel Test
			  </div>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC_SERVEUR" value="'.htmlentities($urlobcprod).'" '.((Tools::getValue('CMCIC_SERVEUR')==htmlentities($urlobcprod) or $conf['CMCIC_SERVEUR']==htmlentities($urlobcprod)) ? ' checked' : '' ).'/> OBC Production&nbsp;
			  <input type="radio" name="CMCIC_SERVEUR" value="'.htmlentities($urlobctest).'" '.((Tools::getValue('CMCIC_SERVEUR')==htmlentities($urlobctest) or $conf['CMCIC_SERVEUR']==htmlentities($urlobctest)) ? ' checked' : '' ).'/> OBC Test
			  </div>
        <br />
			  <label>'.$this->l('Your Email Notification :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC_EMAIL_NOTIFICATION" size=20 maxlength=42 value="'.((!Tools::getValue('CMCIC_EMAIL_NOTIFICATION')) ? $conf['CMCIC_EMAIL_NOTIFICATION'] : Tools::getValue('CMCIC_EMAIL_NOTIFICATION')).'" />
			  </div>	
			  <br />
			  <label>'.$this->l('Management Test Mode :').'</label>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC_IP_TEST_ACTIVE" value="0"'.((Tools::getValue('CMCIC_IP_TEST_ACTIVE')=="0" or $conf['CMCIC_IP_TEST_ACTIVE']=="0") ? ' checked' : '' ).'/>&nbsp;'.$this->l(' still Visible').'&nbsp;
			  <input type="radio" name="CMCIC_IP_TEST_ACTIVE" value="1"'.((Tools::getValue('CMCIC_IP_TEST_ACTIVE')=="1" or $conf['CMCIC_IP_TEST_ACTIVE']=="1") ? ' checked' : '' ).'/>&nbsp;'.$this->l(' Hidden (Visible with the IP below)').'
			  </div>
			  <br />
			  <label>'.$this->l('IP address for the Test Mode :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC_IP_TEST" size=20 maxlength=42 value="'.((!Tools::getValue('CMCIC_IP_TEST')) ? $conf['CMCIC_IP_TEST'] : Tools::getValue('CMCIC_IP_TEST')).'" />
			  </div>	
			  <br />						        		  
		</div>

		<div id="TabConf_02" class="tab_content">
			<br /><br />
        <label>'.$this->l('Monetico version :').'</label>
			  <div class="margin-form">
			  <input type="hidden" name="CMCIC4X_VERSION" value="'.$this->cmcic_ver.'" />V '.$this->cmcic_ver.'
			  </div>
			  <br />			
			  <label>'.$this->l('Enable many times payment :').'</label>
			  <div class="margin-form">
			  <input type="checkbox" name="CMCIC4X_ACTIVE" value="on" '.((Tools::getValue('CMCIC4X_ACTIVE') or $conf['CMCIC4X_ACTIVE']) ? 'checked' : '').' />
			  </div>
			  <br />
			  <label>'.$this->l('TPE number :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC4X_TPE" size=10 maxlength=8 value="'.((!Tools::getValue('CMCIC4X_TPE')) ? $conf['CMCIC4X_TPE'] : Tools::getValue('CMCIC4X_TPE') ).'" />
			  <span>'.$this->l('Seven or eight carracters.').'</span>
			  </div>
			  <br />
			  <label>'.$this->l('Your Company code :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC4X_CODESOCIETE" size=20 maxlength=42 value="'.((!Tools::getValue('CMCIC4X_CODESOCIETE')) ? $conf['CMCIC4X_CODESOCIETE'] : Tools::getValue('CMCIC4X_CODESOCIETE') ).'" />
			  <span>'.$this->l('Has been given by CMCIC').'</span>
			  </div>
			  <br />
			  <label>'.$this->l('Key control :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC4X_CLE" size=60 maxlength=50 value="'.((!Tools::getValue('CMCIC4X_CLE')) ? $conf['CMCIC4X_CLE'] : Tools::getValue('CMCIC4X_CLE') ).'" />
			  <span>'.$this->l('HMAC Key has been given by CMCIC.').'</span>
			  </div>
			  <br />
			  <label>'.$this->l('Minimum purchase :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC4X_MONTANTMINI" size=10 maxlength=42 value="'.((!Tools::getValue('CMCIC4X_MONTANTMINI')) ? $conf['CMCIC4X_MONTANTMINI'] : Tools::getValue('CMCIC4X_MONTANTMINI') ).'" />
			  <span>'.$this->l('Total amnount for the customer.').'</span>
			  </div>
			  <br />
			  <label>'.$this->l('Number of monthly :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC4X_NBMENS" size=10 maxlength=1 value="'.((!Tools::getValue('CMCIC4X_NBMENS')) ? $conf['CMCIC4X_NBMENS'] : Tools::getValue('CMCIC4X_NBMENS') ).'" />
			  <span>'.$this->l('30 days beetween any payment.').'</span>
			  </div>
			  <br />
        <input type="hidden" name="CMCIC4X_MODECALCUL" value="1" />
        <!--
			  <label>'.$this->l('Method of calculation :').'</label>
			  <div class="margin-form">
			  <select name="CMCIC4X_MODECALCUL">
				<option value="1" '.((Tools::getValue('CMCIC4X_MODECALCUL')=='1' or $conf['CMCIC4X_MODECALCUL']=='1') ? 'selected' : '' ).'>Les échéances sont égales entre elles </option>
				<option value="2" '.((Tools::getValue('CMCIC4X_MODECALCUL')=='2' or $conf['CMCIC4X_MODECALCUL']=='2') ? 'selected' : '' ).'>La première échéance est arrondie</option>
			  </select>
			  </div>
			  <br />-->
			  <label>'.$this->l('Your Bank agency:').'</label>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC4X_SERVEUR" value="'.htmlentities($urlmonetprod).'" '.((Tools::getValue('CMCIC4X_SERVEUR')==htmlentities($urlmonetprod) or $conf['CMCIC4X_SERVEUR']==htmlentities($urlmonetprod)) ? ' checked' : '' ).'/> Monetico Production&nbsp;
			  <input type="radio" name="CMCIC4X_SERVEUR" value="'.htmlentities($urlmonettest).'" '.((Tools::getValue('CMCIC4X_SERVEUR')==htmlentities($urlmonettest) or $conf['CMCIC4X_SERVEUR']==htmlentities($urlmonettest)) ? ' checked' : '' ).'/> Monetico Test
			  </div>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC4X_SERVEUR" value="'.htmlentities($urlcicprod).'" '.((Tools::getValue('CMCIC4X_SERVEUR')==htmlentities($urlcicprod) or $conf['CMCIC4X_SERVEUR']==htmlentities($urlcicprod)) ? ' checked' : '' ).'/> CIC Production&nbsp;
			  <input type="radio" name="CMCIC4X_SERVEUR" value="'.htmlentities($urlcictest).'" '.((Tools::getValue('CMCIC4X_SERVEUR')==htmlentities($urlcictest) or $conf['CMCIC4X_SERVEUR']==htmlentities($urlcictest)) ? ' checked' : '' ).'/> CIC Test
			  </div>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC4X_SERVEUR" value="'.htmlentities($urlcmprod).'" '.((Tools::getValue('CMCIC4X_SERVEUR')==htmlentities($urlcmprod) or $conf['CMCIC4X_SERVEUR']==htmlentities($urlcmprod)) ? ' checked' : '' ).'/> Cr&eacute;dit Mutuel Production&nbsp;
			  <input type="radio" name="CMCIC4X_SERVEUR" value="'.htmlentities($urlcmtest).'" '.((Tools::getValue('CMCIC4X_SERVEUR')==htmlentities($urlcmtest) or $conf['CMCIC4X_SERVEUR']==htmlentities($urlcmtest)) ? ' checked' : '' ).'/> Cr&eacute;dit Mutuel Test
			  </div>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC4X_SERVEUR" value="'.htmlentities($urlobcprod).'" '.((Tools::getValue('CMCIC4X_SERVEUR')==htmlentities($urlobcprod) or $conf['CMCIC4X_SERVEUR']==htmlentities($urlobcprod)) ? ' checked' : '' ).'/> OBC Production&nbsp;
			  <input type="radio" name="CMCIC4X_SERVEUR" value="'.htmlentities($urlobctest).'" '.((Tools::getValue('CMCIC4X_SERVEUR')==htmlentities($urlobctest) or $conf['CMCIC4X_SERVEUR']==htmlentities($urlobctest)) ? ' checked' : '' ).'/> OBC Test
			  </div>
			  <br />
			  <label>'.$this->l('Management Test Mode :').'</label>
			  <div class="margin-form">
			  <input type="radio" name="CMCIC4X_IP_TEST_ACTIVE" value="0"'.((Tools::getValue('CMCIC4X_IP_TEST_ACTIVE')=="0" or $conf['CMCIC4X_IP_TEST_ACTIVE']=="0") ? ' checked' : '' ).'/>&nbsp;'.$this->l(' still Visible').'&nbsp;
			  <input type="radio" name="CMCIC4X_IP_TEST_ACTIVE" value="1"'.((Tools::getValue('CMCIC4X_IP_TEST_ACTIVE')=="1" or $conf['CMCIC4X_IP_TEST_ACTIVE']=="1") ? ' checked' : '' ).'/>&nbsp;'.$this->l(' Hidden (Visible with the IP below)').'
			  </div>
			  <br />
			  <label>'.$this->l('IP address for the Test Mode :').'</label>
			  <div class="margin-form">
			  <input type="text" name="CMCIC4X_IP_TEST" size=20 maxlength=42 value="'.((!Tools::getValue('CMCIC4X_IP_TEST')) ? $conf['CMCIC4X_IP_TEST'] : Tools::getValue('CMCIC4X_IP_TEST')).'" />
			  </div>	
			  <br />	
		</div>';
		
    if(file_exists($file_instal)) { include(_PS_MODULE_DIR_.$this->name.'/aide_instal.php'); }
    if(file_exists($file_ccom4)) {include(_PS_MODULE_DIR_.$this->name.'/cour_ccom4.php'); }		
		
	$this->_html .= '
			  <label>'.$this->l('Access Administration').'</label>
        <div class="margin-form">         
        <a href="https://www.monetico-services.com/fr/identification/login.cgi" target="_blank" title="'.$this->l('Click here to go to the back office').' Monetico"><b>'.$this->l('Merchant Dashboard').' Monetico</b></a>  
         &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 
        <a href="https://www.cmcicpaiement.fr/fr/identification/identification.html" target="_blank" title="'.$this->l('Click here to go to the back office').' CM-CIC P@iement"><b>'.$this->l('Merchant Dashboard').' CM-CIC P@iement</b></a>  
        <br /><br />
			  </div>
			  <label><a href="http://hosteco.fr/host/module_paiement_prestashop.php" target="_blank">&copy; Hosteco.fr</a></label>&nbsp;&nbsp;&nbsp;&nbsp;
	      <small>'.$this->l('Payments for other modules you can contact').' : <a href="http://hosteco.fr/host/module_paiement_prestashop.php" target="_blank"  title="'.$this->l('Click here to go on the site of the editor').'"><b>hosteco.fr</b></a></small>
        <br /><br />';

	$this->_html .= '
 			  </div>
			<br />'.$this->l('Payment module').' Monetico - <i>'.$this->l('You must create first your ecommerce account with your bank. ').'</i>
		<center><input type="submit" name="submitCmCic" value="'.$this->l('Save').'" class="button" /></center>

		</div>
		
	</fieldset>
	</form>';

  }

  public function hookOrderConfirmation($params) 
	{
		global $smarty, $cookie;
      		       
//print_r($params) ;

$lien_contact = 'contact-form.php';
if(strstr($_SERVER["REQUEST_URI"], '/fr/')) {$lien_contact = 'fr/nous-contacter';}
if(strstr($_SERVER["REQUEST_URI"], '/en/')) {$lien_contact = 'en/contact-us';}
if(strstr($_SERVER["REQUEST_URI"], '/confirmation-commande?')) {$lien_contact = 'nous-contacter';}
if(strstr($_SERVER["REQUEST_URI"], '/order-confirmation?')) {$lien_contact = 'contact-us';}
/*if($lang->iso_code =='fr') {$lien_contact = 'fr/nous-contacter';$lg_fact='fr/';}
else {$lien_contact = 'en/contact-us';$lg_fact='en/';}
*/
$order_contact = $this->http.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.$lien_contact;

$order_total =  number_format($params['total_to_pay'], 2,',', '')." ".$params['currency'];
$order_payment = $params['objOrder']->payment;
$order_ref = $params['objOrder']->reference;
$order_id = $params['objOrder']->id;


                $this->smarty->assign(array(
                   'order_contact' => $order_contact,
                   'order_payment' => $order_payment,
                   'order_total'   => $order_total, 
                   'order_ref'     => $order_ref,                                    
                   'order_id'      => $order_id
                   	)); 
                   	
//	echo $order_total; echo $order_id; echo $order_payment;
	
//		if (!$this->active)	return;
		if ($params['objOrder']->module != $this->name)
			return;

		if ($params['objOrder']->valid)
			$smarty->assign(array('status' => 'ok', 'id_order' => $params['objOrder']->id));
		else
			$smarty->assign('status', 'failed');

		return $this->display(__FILE__, 'payment_return.tpl');
	}    

	//Gestion des dates d'échéances//	
	public function gestion_dates($nb)
	{
		$date_next = array();
		$actual_month = (int)date("m");
//		$actual_month =  10;
		
		//Vérification date voulue//		
		$date_next['day'] 	= (int)date("d");		
		$date_next['month']	= $actual_month + $nb;
		$date_next['year']	= (int)date("Y");
		
		//Correction pour le changement d'année (mois > 12)// 				
		if( $date_next['month'] > 12 ){
			$date_next['month'] = $date_next['month'] - 12;
      $date_next['year'] = $date_next['year']+1;
		}   
      $date_next['day'] = sprintf("%'.02d", $date_next['day']);
      $date_next['month'] = sprintf("%'.02d", $date_next['month']);      
    
		//Vérification de la date//		
		if( checkdate($date_next['month'],$date_next['day'],$date_next['year']) == false )
			while( checkdate($date_next['month'],$date_next['day'],$date_next['year']) == false )
			{
				$date_next['day']--;
			}
		//Formatage//		
		return $date_next['day'].'/'.$date_next['month'].'/'.$date_next['year'];
	}

  public function hookPayment($params){

	global $smarty, $cookie, $cart;
    
    $sit = Configuration::get('PS_SHOP_NAME');
    $site = htmlentities($sit, NULL, 'utf-8');

	//Variables générales//
	
	$address 		= new Address((int)$cart->id_address_invoice);
    $customer 		= new Customer((int)$cart->id_customer);
    $id_currency 	= (int)$cart->id_currency;
    $currency 		= new Currency((int)$id_currency);
	
	$cmcic_active	= (bool)Configuration::get('CMCIC_ACTIVE');
	$cmcic4X_active = (bool)Configuration::get('CMCIC4X_ACTIVE');

	//Variables paiement une fois//	
	if( $cmcic_active )
	{
		$MyTpe["tpe"]          = trim(Configuration::get('CMCIC_TPE'));
		$MyTpe["codesociete"]  = trim(Configuration::get('CMCIC_CODESOCIETE'));
		$MyTpe["cle"]          = trim(Configuration::get('CMCIC_CLE'));
		$MyTpe["serveur"]      = Configuration::get('CMCIC_SERVEUR');
		
		$sCodeSociete = $MyTpe["codesociete"];
		$sUrlpaiement = $MyTpe["serveur"];
		
		$test_ok = strstr($MyTpe["serveur"],"test");
    $nb_paiement = 'Simple';
    if($test_ok){
		$MyTpe["commentaire"]  = "Hosteco Test - Paiement ".$nb_paiement." - du Panier No ".$cart->id." sur ".$site." par ".$customer->email." - ".$_SERVER["REMOTE_ADDR"];
		} else {
		$MyTpe["commentaire"]  = "Paiement ".$nb_paiement." - du Panier No ".$cart->id." sur ".$site." par ".$customer->email." - ".$_SERVER["REMOTE_ADDR"];
		}
    $MyTpe["options"]    = "";
	}
	
	//Variables paiement plusieurs fois//
	if( $cmcic4X_active )
	{
		$MyTpe["tpe4X"]		   	= trim(Configuration::get('CMCIC4X_TPE'));
		$MyTpe["codesociete4X"] = trim(Configuration::get('CMCIC4X_CODESOCIETE'));
		$MyTpe["cle4X"]         = trim(Configuration::get('CMCIC4X_CLE'));
		$MyTpe["serveur4X"]	   = Configuration::get('CMCIC4X_SERVEUR');
		
		$sCodeSociete4X = $MyTpe["codesociete4X"];
		$sUrlpaiement4X = $MyTpe["serveur4X"];
		
		$test4X_ok = strstr($MyTpe["serveur4X"],"test");
    	
		$nbmens		= Configuration::get('CMCIC4X_NBMENS');
		$modecalcul = Configuration::get('CMCIC4X_MODECALCUL');
    $nb_paiement = 'en '.$nbmens.' Fois';	
    if($test4X_ok){
		$MyTpe["commentaire4X"]  = "Hosteco Test - Paiement ".$nb_paiement." - du Panier No ".$cart->id." sur ".$site;
		} else {
		$MyTpe["commentaire4X"]  = "Paiement ".$nb_paiement." - du Panier No ".$cart->id." sur ".$site;
		}  
      		
	}
	
if (version_compare(_PS_VERSION_, '1.5', '>')) {   	
    $cart_details = $cart->getSummaryDetails(null, true);
    $monant_btq = $cart_details['total_price'];
} else {
    $monant_btq = Tools::convertPrice($params['cart']->getOrderTotal(true, 3), $currency);
}

//	print_r($cart_details);
// $cart_details['id_shop'];

    $lang_iso = Language::getIsoById(intval($cookie->id_lang));
    $lang_monetico = substr(strtoupper(Language::getLanguageCodeByIso($lang_iso)),0,2);
    //echo $lang_iso.'-'.$lang_monetico;

$lien_confirm = 'index.php?controller=order-confirmation';
if(strstr($_SERVER["REQUEST_URI"], '/fr/')) {$lien_confirm = 'fr/confirmation-commande';}
if(strstr($_SERVER["REQUEST_URI"], '/en/')) {$lien_confirm = 'en/order-confirmation';}
if($_SERVER["REQUEST_URI"]  == '/commande') {$lien_confirm = 'confirmation-commande';}
if($_SERVER["REQUEST_URI"] == '/order') {$lien_confirm = 'order-confirmation';}
$lien_order = str_replace(__PS_BASE_URI__,'',$_SERVER["REQUEST_URI"]);
$lien_order = str_replace('fr','fr/',$lien_order);
$lien_order = str_replace('en','en/',$lien_order);
$lien_order = str_replace('?step=3','',$lien_order);
/*
echo $lien_order;
echo '<br>';
echo __PS_BASE_URI__;
*/
	//Paramètres généraux si un des deux type de paiement est activé//		
	if( $cmcic_active or $cmcic4X_active )
	{
		$MyTpe["retourok"]    = htmlspecialchars($this->http.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.$lien_confirm.'?id_cart='.$cart->id.'&id_module='.$this->id.'&key=', ENT_COMPAT, 'UTF-8').$customer->secure_key;
		$MyTpe["retournok"]   = htmlspecialchars($this->http.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.$lien_order.'?step=3', ENT_COMPAT, 'UTF-8');
		$MyTpe["reference"]   = $cart->id." - ".date("si");
		$MyTpe["devise"]      = strtoupper($currency->iso_code);

		$MyTpe["langue"]      = $lang_monetico;//strtoupper(Language::getIsoById(intval($cookie->id_lang)));
		$MyTpe["version"]	    = Configuration::get('CMCIC_VERSION');	
		$MyTpe["montant"]     = number_format($monant_btq, 2, '.', '');
		$MyTpe["submit"]	    = $this->l('Paiement sécurisé par carte bancaire');
		$MyTpe["date"]		    = date("d/m/Y:H:i:s");
		$MyTpe["email"]		    = $customer->email;
		
		$sLangue		= $MyTpe["langue"];
		$sVersion		= $MyTpe["version"];
		$sUrlOK			= $MyTpe["retourok"];
		$sUrlKO			= $MyTpe["retournok"];
		$montant		= $MyTpe["montant"];
		
    }
	  
    //Cryptage Euro Information version 1.04 (Fonctions)//

  require_once(_PS_MODULE_DIR_.$this->name."/Monetico_Config.php");    
	require_once(_PS_MODULE_DIR_.$this->name."/Monetico_Tpe.inc.php");
    
    $oTpe 		= new CMCIC_Tpe($sLangue);
    $oHmac		= new CMCIC_Hmac($oTpe);
	$oTpe4X 	= new CMCIC_Tpe_4X($sLangue);
	$oHmac4X 	= new CMCIC_Hmac($oTpe4X);


	//Echéances si CMCIC4X est activé//	
	if( $cmcic4X_active )
	{
		switch ($nbmens){
			case '2':
	
				//2 échéances//				
				$date1 = date("d/m/Y");
				$date2 = $this->gestion_dates(1);
				if($modecalcul=='1'){
					$mensualite1 = round(($montant/2),2);
					$mensualite2 = round(($montant-$mensualite1),2);
				} else if($modecalcul=='2'){
					$mensualite2 = round(($montant/2),0);
					$mensualite1 = ($montant-$mensualite2);
				}
				break;
			
			case '3':
			
				//3 échéances//				
				$date1 = date("d/m/Y");
				$date2 = $this->gestion_dates(1);
				$date3 = $this->gestion_dates(2);
				if($modecalcul=='1'){
					$mensualite1 = round(($montant/3),2);
					$mensualite2 = round(($montant/3),2);
					$mensualite3 = ($montant - $mensualite1 - $mensualite2);
				} else if($modecalcul=='2'){
					$mensualite3 = round(($montant/3),0);
					$mensualite2 = round(($montant/3),0);
					$mensualite1 = ($montant-$mensualite2-$mensualite3);
				}
				break;
				
			case '4':
				
				//4 échéances//				
				$date1 = date("d/m/Y");
				$date2 = $this->gestion_dates(1);
				$date3 = $this->gestion_dates(2);
				$date4 = $this->gestion_dates(3);
				if($modecalcul=='1'){
					$mensualite1 = round(($montant/4),2);
					$mensualite2 = round(($montant/4),2);
					$mensualite3 = round(($montant/4),2);
					$mensualite4 = ($montant - $mensualite1 - $mensualite2 - $mensualite3);
				} else if($modecalcul=='2'){
					$mensualite4 = round(($montant/4),0);
					$mensualite3 = round(($montant/4),0);
					$mensualite2 = round(($montant/4),0);
					$mensualite1 = ($montant-$mensualite2-$mensualite3-$mensualite4);
				}
				break;
				
			default:
				
				//Paiement par défaut//				
				$date1 = date("d/m/Y");
				$date2 = $this->gestion_dates(1);
				$date3 = $this->gestion_dates(2);
				if($modecalcul=='1'){
					$mensualite1 = round(($montant/3),2);
					$mensualite2 = round(($montant/3),2);
					$mensualite3 = ($montant - $mensualite1 - $mensualite2);
				} else if($modecalcul=='2'){
					$mensualite3 = round(($montant/3),0);
					$mensualite2 = round(($montant/3),0);
					$mensualite1 = ($montant-$mensualite2-$mensualite3);
				}
				break;
		}
	
		$mensualite1 = number_format(Tools::convertPrice($mensualite1, $currency), 2, '.', '');
		$mensualite2 = number_format(Tools::convertPrice($mensualite2, $currency), 2, '.', '');
		if(isset($mensualite3))
			$mensualite3 = number_format(Tools::convertPrice($mensualite3, $currency), 2, '.', '');
		if(isset($mensualite4))
			$mensualite4 = number_format(Tools::convertPrice($mensualite4, $currency), 2, '.', '');
			
		//Variables à créer si vide//		
		if( !isset($date3) )
			$date3 = '';
		if( !isset($date4) )
			$date4 = '';
		if( !isset($mensualite3) )
			$mensualite3 = '';
		if( !isset($mensualite4) )
			$mensualite4 = '';
			
		//Clé paiement en plusieurs fois début//		
		$Hmac1_4X = $oHmac4X->computeHmac(sprintf(CMCIC_CTLHMACSTR,$MyTpe["version"],$MyTpe["tpe4X"]));    
		$CtlHmac_4X = sprintf(CMCIC_CTLHMAC,$MyTpe["version"],$MyTpe["tpe4X"],$Hmac1_4X); 
       
		$PHP1_FIELDS_4X = sprintf(CMCIC_CGI1_FIELDS, $oTpe4X->sNumero,
    $MyTpe["date"],$MyTpe["montant"],$MyTpe["devise"],$MyTpe["reference"],
		$MyTpe["commentaire4X"], $sVersion, $sLangue, $sCodeSociete4X,
		$MyTpe["email"], intval($nbmens), $date1, $mensualite1.$MyTpe["devise"],
    $date2, $mensualite2.$MyTpe["devise"], $date3,(($mensualite3) ? $mensualite3.$MyTpe["devise"] : '' ),
    $date4,(($mensualite4) ? $mensualite4.$MyTpe["devise"] : '' ),"");    	
    										
		$sMac_4X = $oHmac4X->computeHmac($PHP1_FIELDS_4X);		
		//Clé pour paiement en plusieurs fois fin//

	}
	

	if( $cmcic_active )
	{
		//Clé paiement en une fois début//
		
		$Hmac1 = $oHmac->computeHmac(sprintf(CMCIC_CTLHMACSTR,$MyTpe["version"],$MyTpe["tpe"]));
		$CtlHmac = sprintf(CMCIC_CTLHMAC,$MyTpe["version"],$MyTpe["tpe"],$Hmac1);
		
		$PHP1_FIELDS = sprintf(CMCIC_CGI1_FIELDS, $oTpe->sNumero,
    $MyTpe["date"], $MyTpe["montant"], $MyTpe["devise"], $MyTpe["reference"],
		$MyTpe["commentaire"], $sVersion, $sLangue, $sCodeSociete,
		$MyTpe["email"],"","","","","","","","","",$MyTpe["options"]);
     											
		$sMac = $oHmac->computeHmac($PHP1_FIELDS);	
		//Clé paiement en une fois fin//
		
	}
	
	
	if( $cmcic_active or $cmcic4X_active )
	{
		if(substr_count($MyTpe["serveur"],"cic")>0){
			$smarty->assign('Bank', "logocic.jpg");
		} elseif(substr_count($MyTpe["serveur"],"creditmutuel")>0){
			$smarty->assign('Bank', "logocm.jpg");
		} elseif(substr_count($MyTpe["serveur"],"obc")>0){
			$smarty->assign('Bank', "logoobc.jpg");
		} elseif(substr_count($MyTpe["serveur"],"monetico")>0){
			$smarty->assign('Bank', "logomonetico.jpg");
		}	
		
		if(substr_count($MyTpe["serveur4X"],"cic")>0){
			$smarty->assign('Bank4x', "logocic.jpg");
		} elseif(substr_count($MyTpe["serveur4X"],"creditmutuel")>0){
			$smarty->assign('Bank4x', "logocm.jpg");
		} elseif(substr_count($MyTpe["serveur4X"],"obc")>0){
			$smarty->assign('Bank4x', "logoobc.jpg");
		}	elseif(substr_count($MyTpe["serveur4X"],"monetico")>0){
			$smarty->assign('Bank4x', "logomonetico.jpg");
		}
    	
	}
	

	//Variables si un des deux paiements est activé//	
	if( $cmcic_active or $cmcic4X_active )
	{
		$smarty->assign('version',$sVersion);
		$smarty->assign('date',$MyTpe["date"]);
		$smarty->assign('devise',$MyTpe["devise"]);
		$smarty->assign('montant',$MyTpe["montant"]);
		$smarty->assign('reference',$MyTpe["reference"]);
		$smarty->assign('urlRetourNOK',$MyTpe["retournok"]);
		$smarty->assign('urlRetourOK',$MyTpe["retourok"]);
		$smarty->assign('langue',$MyTpe["langue"]);
		$smarty->assign('mail',$MyTpe["email"]);
	}
	
	$smarty->assign('activecomptant','off');
	//Paiement en une fois si activé//
		
	if( $cmcic_active )
	{
		$smarty->assign('activecomptant',Configuration::get('CMCIC_ACTIVE'));
		$smarty->assign('montant_mini',Configuration::get('CMCIC_MONTANTMINI'));		
		$smarty->assign('Serveur',$sUrlpaiement);
		$smarty->assign('tpe',$oTpe->sNumero);
		$smarty->assign('codesociete',$MyTpe["codesociete"]);
		$smarty->assign('Hmac',$sMac);
		$smarty->assign('texte_paiement',$this->l('Pay by credit card (CB, VISA, MASTERCARD, ...)'));
		$smarty->assign('commentaire',HtmlEncode($MyTpe["commentaire"]));	
    $smarty->assign('options',$MyTpe["options"]	);

$active_ip = Configuration::get('CMCIC_IP_TEST_ACTIVE');
$monetico_ip = Configuration::get('CMCIC_IP_TEST'); 
$test_1f = strstr(Configuration::get('CMCIC_SERVEUR'),'test');

if(
( $active_ip == '1' && $monetico_ip == $_SERVER["REMOTE_ADDR"] && $test_1f != '' )
OR ( $active_ip == '0' && $test_1f != '' )
OR ( $test_1f == '' )
 ){$cmcic_aff_ok = '1';} else {$cmcic_aff_ok = '0';}
$smarty->assign('cmcic_aff_ok',$cmcic_aff_ok); 
	}
	
		$smarty->assign('activexfois','off');
		
  //Paiement en plusieurs fois si activé//
	if( $cmcic4X_active )
	{
		$smarty->assign('activexfois',Configuration::get('CMCIC4X_ACTIVE'));
		$smarty->assign('montantmini',Configuration::get('CMCIC4X_MONTANTMINI'));
		$smarty->assign('Serveur_4X',$sUrlpaiement4X);
		$smarty->assign('tpe4X',$oTpe4X->sNumero);
		$smarty->assign('codesociete4X',$MyTpe["codesociete4X"]);
		$smarty->assign('commentaire4X',HtmlEncode($MyTpe["commentaire4X"]));		
		$smarty->assign('nbmens',$nbmens);
		$smarty->assign('date1',$date1);
		$smarty->assign('date2',$date2);
		$smarty->assign('mensualite1',$mensualite1);
		$smarty->assign('mensualite2',$mensualite2);	
    	
		//Si date3 existe//		
		if( isset($date3) )
			$smarty->assign('date3',$date3);
		
		//Si date4 existe//		
		if( isset($date4) )
			$smarty->assign('date4',$date4);
		
		//Si mensualite3 existe//		
		if( isset($mensualite3) )
			$smarty->assign('mensualite3',$mensualite3);
		
		//Si mensualite4 existe//		
		if( isset($mensualite4) )
			$smarty->assign('mensualite4',$mensualite4);
			
		$smarty->assign('Hmac_4X',$sMac_4X);
		$smarty->assign('texte_paiement_4X',$this->l('Pay in ').$nbmens.$this->l(' Time without fees by credit card (CB, VISA, MASTERCARD, ...)'));

  $active_ip = Configuration::get('CMCIC4X_IP_TEST_ACTIVE');
  $monetico_ip = Configuration::get('CMCIC4X_IP_TEST');
  $test_xf = strstr(Configuration::get('CMCIC4X_SERVEUR'),'test'); 
  
if(
( $active_ip == '1' && $monetico_ip == $_SERVER["REMOTE_ADDR"] && $test_xf != '' )
OR ( $active_ip == '0' && $test_xf != '' )
OR ( $test_xf == '' )
 ){$cmcic4X_aff_ok = '1';} else {$cmcic4X_aff_ok = '0';}
$smarty->assign('cmcic4X_aff_ok',$cmcic4X_aff_ok);
	}
	
    return $this->display(__FILE__, 'moneticoxf.tpl');
    
	}

}
/*
 Module de paiement Monetico pour le CM-CIC Par hosteco.fr 2012-2018. 
*/
?>
